# 小试牛刀🐂——几个题

## Hadoop入门几个题

- 简单描述如何安装配置Apache的一个开源Hadoop

  ```
  1. 准备好客户机并配置好IP、主机名、关闭防火墙等
  2. 安装JDK、Hadoop并配置环境且使之生效（source /etc/profile）
  3. 配置ssh(ssh-keygen -t rsa)配置免密登录(ssh-copy-id)
  4. 准备分发脚本xsyc
  5. 明确集群配置
  6. 修改配置文件
  	1. 4个(core、hdfs、yarn、mapred)-site.xml
  	2. 3个(hdfs、yarn、mapred)-env.xml
  	3. 1个slaves
  7. 分发配置完的配置文件到其他机器
  8. 格式化hdfs（hdfs namenode -format）
  9. 启动hdfs（start-dfs.sh）
  配置了ResourceManager机器上启动yarn（start-yarn.sh）
  ```

- Hadoop中需要哪些配置文件，作用是什么

  ```
  4个核心配置文件
  1. core-site.xml：集群全局参数：定义系统级别参数，如，HDFS URL、Hadoop临时目录等
  2. hdfs-site.xml：HDFS参数：namenode和datanode存放位置、文件副本数、文件读取权限等
  3. mapred-site.xml：MapReduce参数：配置JobHistory Server和应用程序参数，reduce任务的默认个数，任务所能使用内存的默认上下限等
  4. yarn-site.xml：集群资源管理系统参数：配置 ResourceManager通信地址，NodeManager的通信端口，web监控端口等
  ```

- 正常工作的Hadoop集群中要分别启动哪些进程，它们的作用是什么

  ```
  1. NameNode它是hadoop中的主服务器，管理文件系统信息和对集群中存储的文件的访问，保存metadate。
  2. SecondaryNameNode它不是namenode的冗余守护进程，而是提供周期检查点和清理任务。帮助NN合并editslog和fsimage，减少NN启动时间。
  3. DataNode它负责管理连接到节点的存储（一个集群中可以有多个节点）。每个存储数据的节点运行一个datanode守护进程。
  4. ResourceManager（JobTracker）JobTracker负责调度DataNode上的工作。每个DataNode有一个TaskTracker，它们执行实际工作。
  5. NodeManager（TaskTracker）执行任务。
  ```

- 简述Hadoop的几个默认端口及其含义

  ```
  1. NameNode:50070（3.X为9870）
  2. SecondaryNameNode：50090（3.X为9868）
  3. DataNode:50010
  4. ResourceManager:8088
  5. MapReduce JobHistory Server:19888
  ```

-----

## HDFS入门几个题

- HDFS读写流程
- SecondaryNameNode工作机制
- NameNode和SecondaryNameNode区别与联系
- 服役新数据节点和退役旧数据节点步骤

## MapReduce入门几个题

- 谈谈Hadop序列化和反序列化以及自定义bean对象实现序列化
- FileInputFormat切片机制
- 自定义InputFormat流程
- 如何决定一个job的map和reduce数量
- MapTask的个数由什么决定
- MapTask工作机制
- ReduceTask工作机制
- 简述MapReduce有几种排序，执行几次，发生在什么阶段
- 简述Mapreduce中的shuffle阶段工作流程，如何优化shuffle阶段
- 简述MapReduce中combiner作用，一般使用场景，哪些情况不需要使用，以及和Reduce的区别
- 简述MapReduce工作原理，
- 如果没有定义partitioner，数据在被送到Reduce之前如何被分区
- MapReduce的TopN
- Hadoop任务能输出到多个目录中吗？如果可以怎么做？
- 简述Hadoop实现join的集中方法，每种方法的实现方法
- 简述Hadoop实现二级排序
- 简述Hadoop中RecordReader作用

-----

## YARN入门几个题

- Hadoop1.X和Hadoop2.X架构的异同
- 为什么会产生YARN，它解决什么问题，优势是什么
- MapReduce作业提交全过程
- HDFS数据压缩算法
- Hadoop的调度器总结
- MapReduce推测执行算法及原理

-----

## Hadoop优化几个题

- MapReduce跑的慢的原因
- MapReduce优化方法
- HDFS小文件的优化方法
- MapReduce解决数据均衡的几个方法，如何确定分区号
- Hadoop中job和Task的区别

## Zookeeper几个题

- 简述Zookeeper选举机制

  ```
  1. 半数选举机制（Paxos算法）：集群中半数以上机器存活，集群可用。所以zookeeper适合装在奇数台机器上
  2. 
  ```

  

- 简述Zookeeper监听原理

- Zookeeper常用命令

  ```
  1. 创建节点
  	create [-s] [-e] path data acl
  2. 读取节点数据
  	get path [watch]
  3. 更新节点数据
  	set path data [version]
  4. 删除节点
  	delete path [version]
  	rmr path
  5. 监控节点变化
  	
  ```

  